Subject: Re: [PATCH/RFC] Makefile: Fix compilation of windows resource file

From: Johannes Sixt <[email-masked]>
Date: Wed, 22 Jan 2014 07:55:40 +0100

[Cc Pat, who added git.rc]

Am 1/22/2014 0:48, schrieb Junio C Hamano:
> Ramsay Jones <[email-masked]> writes:
> 
>>> Note that I am merely guessing that "short-digit" version numbers
>>> are acceptable by now after seeing
>>>
>>>     https://sourceware.org/ml/binutils/2012-07/msg00199.html
>>
>> Ah, nice find!
>>
>> I will test your patch (below) and let you know soon, but it looks
>> good to me. (I can't test it tonight, unfortunately.)
> 
> One thing to note is that I don't know why the existing code dropped
> the fourth digit from the maintenance series.

I don't know either. But it does not really matter. When there are 4
digits in the FILEVERSION and PRODUCTVERSION statements, then the user
does not see them as-are, but, for example, 1.8.1283 for
FILEVERSION 1,8,5,3 (1283 = 5*256+3). Therefore, I think that there is
no point in providing 4 numbers, and the patch below should be
sufficient.

diff --git a/Makefile b/Makefile
index b4af1e2..99b2b89 100644
--- a/Makefile
+++ b/Makefile
@@ -1773,7 +1773,7 @@ $(SCRIPT_LIB) : % : %.sh GIT-SCRIPT-DEFINES
 
 git.res: git.rc GIT-VERSION-FILE
 	$(QUIET_RC)$(RC) \
-	  $(join -DMAJOR= -DMINOR= -DPATCH=, $(wordlist 1,3,$(subst -, ,$(subst ., ,$(GIT_VERSION))))) \
+	  $(join -DMAJOR= -DMINOR=, $(wordlist 1,2,$(subst -, ,$(subst ., ,$(GIT_VERSION))))) \
 	  -DGIT_VERSION="\\\"$(GIT_VERSION)\\\"" $< -o $@
 
 ifndef NO_PERL
diff --git a/git.rc b/git.rc
index bce6db9..33aafb7 100644
--- a/git.rc
+++ b/git.rc
@@ -1,6 +1,6 @@
 1 VERSIONINFO
-FILEVERSION     MAJOR,MINOR,PATCH,0
-PRODUCTVERSION  MAJOR,MINOR,PATCH,0
+FILEVERSION     MAJOR,MINOR,0,0
+PRODUCTVERSION  MAJOR,MINOR,0,0
 BEGIN
   BLOCK "StringFileInfo"
   BEGIN